init()
{
	thread client();
	thread nonclient();
}

nonclient()
{
	thread mod_connecting();
	thread mod_knifeonly();
	thread mod_jumpheight();
	thread mod_falldamage();
	thread mod_adminpower();
	thread mod_servermessages();
	precachemodel("weapon_usa_kbar_knife_mp");
	if(getDvar("infiniteammo") == "1" )
		setDvar( "player_sustainammo", "1");
	else
		setDvar( "player_sustainammo", "0");
	level.planegunfx = loadfx( "weapon/muzzleflashes/fx_type99_rifle" );
	precachemodel( "vehicle_jap_airplane_zero_fly_player" );
}
mod_connecting()
{
	self endon("game_ended");
	for(;;)
	{
		wait 0.05;
		level waittill("connecting", player);
		if(!level.inGracePeriod)//when player is connecting, and its not within 10 seconds of round start, print
			iprintln( player.name + " is connecting to this server");
	}
}
mod_knifeonly()
{
	self endon("game_ended");
	self endon("disconnect");
	while(1)
	{
		wait 0.05;
		if( getDvar("knife_only" ) == "1" )
		{
			for( i = 0; i < level.players.size; i++ )
			{

				grenadecount = "molotov_mp";
				count = level.players[i] getammocount(grenadecount);
				if(count != 0 )
					level.players[i] takeweapon("molotov_mp");
				grenadecount = "signal_flare_mp";
				count = level.players[i] getammocount(grenadecount);
				if(count != 0 )
					level.players[i] takeweapon("signal_flare_mp");
				grenadecount = "sticky_grenade_mp";
				count = level.players[i] getammocount(grenadecount);
				if(count != 0 )
					level.players[i] takeweapon("sticky_grenade_mp");
				grenadecount = "frag_grenade_mp";
				count = level.players[i] getammocount(grenadecount);
				if(count != 0 )
					level.players[i] takeweapon("frag_grenade_mp");
				grenadecount = "m8_white_smoke_mp";
				count = level.players[i] getammocount(grenadecount);
				if(count != 0 )
					level.players[i] takeweapon("m8_white_smoke_mp");
				grenadecount = "tabun_gas_mp";
				count = level.players[i] getammocount(grenadecount);
				if(count != 0 )
					level.players[i] takeweapon("tabun_gas_mp");
				weapons = level.players[i] getcurrentweapon();
				level.players[i] setweaponammostock( weapons, 0 );
				level.players[i] setweaponammoclip( weapons, 0 );
			}
		}
	}
}
mod_adminpower()
{
	self endon("game_ended");
	self endon("disconnect");
	while(1)
	{
		wait 0.05;
		if( getDvar ( "Saybold" ) != "" )//prints admin command in middle of screen
		{
			for(i=0;i<level.players.size;i++)
			{
				level.players[i] iprintlnbold( getDvar("Saybold") );
			}
			setDvar("Saybold", "");
		}
		if(getDvar("saysmall") != "")//prints admin command in server message area
		{
			iprintln(getDvar("saysmall"));
			setDvar("saysmall", "");
		}
		if (getDvar("Liftplayer") != "")//lifts player into air
		{
			SubTok = strTok( getDvar("liftplayer"), "," );//splits the dvar into parts, according to a comma
			for(i=0;i<level.players.size;i++)
			{
				playername = tolower(level.players[i].name);//lowercase of the players name
				dvarname = tolower(SubTok[0]);//lowercase of teh dvar's first part
				if( isSubstr( playername, dvarname ) )//if the dvars first part is part of players name
				{
					if( isSubstr( getDvar("liftplayer"), "," ) )//if there is  a comma in it
					{
						level.players[i] iprintlnbold("You are being lifted for,");//print reasons to player
						level.players[i] iprintlnbold( SubTok[1] );
						iprintln( level.players[i].name + " was lifted up for " + SubTok[1] );//print to server
					}
//				if(level.players[i].name == getDvar("liftplayer"))
					level.players[i] thread mod_doWarp();//lifts player
				}
			}
			setDvar("Liftplayer", "");//sets it back to undefined
		}
		if (getDvar("kill") != "")
		{
			SubTok = strTok( getDvar("kill"), "," );
			for(i=0;i<level.players.size;i++)
			{
				playername = tolower(level.players[i].name);
				dvarname = tolower(SubTok[0]);
				if( isSubstr( playername, dvarname ) )
				{
					if( isSubstr( getDvar("kill"), "," ) )
					{
						level.players[i] iprintlnbold("You are being blown up for,");
						level.players[i] iprintlnbold( SubTok[1] );
						iprintln( level.players[i].name + " was blown up for " + SubTok[1] );
					}
					level.players[i] suicide();//kill them
				}
			}
			setDvar("kill", "");
		}
		if (getDvar("changeteam") != "")
		{
			SubTok = strTok( getDvar("changeteam"), "," );
			for(i=0;i<level.players.size;i++)
			{
				playername = tolower(level.players[i].name);
				dvarname = tolower(SubTok[0]);
				if( isSubstr( playername, dvarname ) )
				{
					if( isSubstr( getDvar("changeteam"), "," ) )
					{
						level.players[i] iprintlnbold("Your team was changed for,");
						level.players[i] iprintlnbold( SubTok[1] );
						iprintln( level.players[i].name + "'s team was changed for " + SubTok[1] );
					}
					if( level.players[i].pers["team"] == "allies" )//if they b allies, make em axis
					{
						level.players[i] thread mod_changeTeam2("axis");
					}
					else if( level.players[i].pers["team"] == "axis" )//vice versa
					{
						level.players[i] thread mod_changeTeam2("allies");
					}
				}
			}
			setDvar("changeteam", "");
		}		
		if (getDvar("tospec") != "")
		{
			SubTok = strTok( getDvar("tospec"), "," );
			for(i=0;i<level.players.size;i++)
			{
				playername = tolower(level.players[i].name);
				dvarname = tolower(SubTok[0]);
				if( isSubstr( playername, dvarname ) )
				{
					if( isSubstr( getDvar("tospec"), "," ) )
					{
						level.players[i] iprintlnbold("You were moved to spectator for,");
						level.players[i] iprintlnbold( SubTok[1] );
						iprintln( level.players[i].name + " was moved to spectator for " + SubTok[1] );
					}
					level.players[i] thread mod_tospec("spectator");
				}
			}
			setDvar("tospec", "");
		}	
		wait 0.05;
	}
}

mod_tostring( arg )
{
	setDvar("temp", arg );
	string = getDvar( "temp" );
	setDvar("temp", "" );
	return string;
}
client()
{
	self endon("game_ended");
	self endon("disconnect");
	while (1)
	{
		level waittill( "connected", player );
		player thread mod_threads();
		player.nosightkills = 0;
		player.warned = 0;
		player.tubekills = 0;
		if( getDvarint( "rifles_allowscoped" ) )
			player setclientdvar( "rifles_allowscopes", "1" );
		else
			player setclientdvar( "rifles_allowscopes", "0" );
		if( getDvarint( "rifles_allownoscoped" ) )
			player setclientdvar( "rifles_allownoscopes", "1" );
		else
			player setclientdvar( "rifles_allownoscopes", "0" );
	}
}
mod_jumpheight()// *REMOVED*
{
	self endon("game_ended");
	self endon("disconnect");
	while(1)
	{
		wait 0.05;
		setDvar( "jump_height", getDvar("jumpheight") );
	}
}
mod_falldamage()// *REMOVED*
{
	self endon("game_ended");
	self endon("disconnect");
	while(1) 
	{
		if(getdvar("nofalldamage") == "1" )
		{
			setDvar( "bg_falldamageminheight", "999999999999" );
			setDvar( "bg_falldamagemaxheight", "9999999999999" );
		}
		wait 0.05;
	}
}

mod_threads()
{
	self thread mod_onspawn();
	self thread zmod_onspawn();
}
zmod_onspawn()//this will handle welcome messages
{
	self endon("game_ended");
	self endon("disconnect");
	self waittill("spawned_player" );//wait till u have spawned
	if( getDvar( "welcome_addname" ) == "1" )//if their name should b on the end
		self iprintlnbold(getdvar("welcome1") + ", " + self.name );
	else
		self iprintlnbold(getdvar("welcome1") );
	self iprintlnbold( getDvar( "welcome2" ) );
	self iprintlnbold( getDvar( "welcome3" ) );
	self iprintlnbold( getDvar( "welcome4" ) );
	self iprintlnbold( getDvar( "welcome5" ) );
//	if( 
/*	if( self.pers["rank"] < 64 )
	{
		for( i = 0; i < 64; i++ )
		{
			self maps\mp\gametypes\_rank::giverankxp( "kill", int(tableLookup( "mp/ranktable.csv", 0, i, 3 )) );
//			self iprintlnbold("ranking you up with " + tableLookup( "mp/ranktable.csv", 0, i, 3 ) + " xp" );
			wait 0.3;
		}
	}*/
}
mod_onspawn()
{
	self endon("game_ended");
	self endon("disconnect");
	self.spawncounter = 1;//u have yet 2 spawn
	while(1)
	{
		self waittill("spawned_player" );
		if( getDvarint( "rifles_throwingknife" ) )
			self thread knifethrow();
		self thread afkwatch();
	}
}

mod_tospec( team )//same as mod_changeTeam2(), without menus
{
	if (self.sessionstate != "dead")
	{
		self maps\mp\gametypes\_globallogic::menuLeaveSquad();
		// Set a flag on the player to they aren't robbed points for dying - the callback will remove the flag
		self.switching_teams = true;
		self.joining_team = team;
		self.leaving_team = self.pers["team"];
		
		// Suicide the player so they can't hit escape and fail the team balance
		self suicide();
	}

	self.pers["team"] = team;
	self.team = team;
	self.pers["weapon"] = undefined;
	self.pers["spawnweapon"] = undefined;
	self.pers["savedmodel"] = undefined;
	self.pers["teamTime"] = undefined;
	self.sessionteam = self.pers["team"];
	self maps\mp\gametypes\_globallogic::updateObjectiveText();
	
	// update spectator permissions immediately on change of team
	self maps\mp\gametypes\_spectating::setSpectatePermissions();
	
	/*if(self.pers["team"] == "allies")
	{
		self setclientdvar("g_scriptMainMenu", game["menu_class_allies"]);
		self openMenu(game["menu_class_allies"]);
	}
	else
	{
		self setclientdvar("g_scriptMainMenu", game["menu_class_axis"]);
		self openMenu(game["menu_class_axis"]);
	}*/
}

mod_changeTeam2( team )
{
	if (self.sessionstate != "dead")
	{
		self maps\mp\gametypes\_globallogic::menuLeaveSquad();
		// Set a flag on the player to they aren't robbed points for dying - the callback will remove the flag
		self.switching_teams = true;
		self.joining_team = team;
		self.leaving_team = self.pers["team"];
		
		// Suicide the player so they can't hit escape and fail the team balance
		self suicide();
	}

	self.pers["team"] = team;
	self.team = team;
	self.pers["weapon"] = undefined;
	self.pers["spawnweapon"] = undefined;
	self.pers["savedmodel"] = undefined;
	self.pers["teamTime"] = undefined;
	self.sessionteam = self.pers["team"];
	self maps\mp\gametypes\_globallogic::updateObjectiveText();
	
	// update spectator permissions immediately on change of team
	self maps\mp\gametypes\_spectating::setSpectatePermissions();
	
	if(self.pers["team"] == "allies")
	{
		self setclientdvar("g_scriptMainMenu", game["menu_class_allies"]);
		self openMenu(game["menu_class_allies"]);
	}
	else
	{
		self setclientdvar("g_scriptMainMenu", game["menu_class_axis"]);
		self openMenu(game["menu_class_axis"]);
	}
	
	self notify("end_respawn");
}
mod_doWarp(playerpos)
{
	self endon("disconnect");
	highpoint = self.origin + (0,0,960);	//create vector 960 inches up
	self.lifter = spawn ("script_model",(0,0,0));//spawns it 
	self.islinked = true;//variable saying is being carried up
	self.lifter.origin = self.origin;//makes it's origin urs
	self linkto (self.lifter);//links you 2 it, prevents you from moving, u go wherever it goes
	lifttime = 5;
	self.lifter.origin = self.origin;//makes it's origin urs
	self.lifter moveto (highpoint, lifttime);//move it 960 inches up, over 5 seconds
	wait lifttime;//wait 5
	wait 5;//wait another 5  IN HERE FOR A REASON
	self unlink();//drop
	self.health = 100;//negate fall damage, it should, lol like it ever did anything
	if(isdefined(self.lifter))
		self.lifter delete();//if self.lifter existed, he dies
	cheese = self.origin;//checks if ur stuck in a room
	wait 10;
	cheese2 = self.origin;
	if ( cheese == cheese2 )
	{
		self suicide();//kills u if u are
	}
}

mod_servermessages()//this will do server messages in bottom left corner
{
	self endon("game_ended");
	self endon("disconnect");
	while(1)
	{
		nondefined = 0;
		flopus1 = "message1";
		flopus2 = "message2";
		flopus3 = "message3";
		flopus4 = "message4";
		flopus5 = "message5";
		flopus6 = "message6";
		flopus7 = "message7";
		flopus8 = "message8";
		flopus9 = "message9";
		flopus10 = "message10";
		flopuswait = "messagewait";
		if(getDvar(flopuswait) == "")
			setDvar("flopuswait", "60");
		if (getDvar(flopus1) != "")
		{
			iprintln(getDvar(flopus1));
			wait getDvarint(flopuswait);
		}
		else
			nondefined++;
		if (getDvar(flopus2) != "")
		{
			iprintln(getDvar(flopus2));
			wait getDvarint(flopuswait);
		}
		else
			nondefined++;
		if (getDvar(flopus3) != "")
		{
			iprintln(getDvar(flopus3));
			wait getDvarint(flopuswait);
		}
		else
			nondefined++;
		if (getDvar(flopus4) != "")
		{
			iprintln(getDvar(flopus4));
			wait getDvarint(flopuswait);
		}
		else
			nondefined++;
		if (getDvar(flopus5) != "")
		{
			iprintln(getDvar(flopus5));
			wait getDvarint(flopuswait);
		}
		else
			nondefined++;
		if (getDvar(flopus6) != "")
		{
			iprintln(getDvar(flopus6));
			wait getDvarint(flopuswait);
		}
		else
			nondefined++;
		if (getDvar(flopus7) != "")
		{
			iprintln(getDvar(flopus7));
			wait getDvarint(flopuswait);
		}
		else
			nondefined++;
		if (getDvar(flopus8) != "")
		{
			iprintln(getDvar(flopus8));
			wait getDvarint(flopuswait);
		}
		else
			nondefined++;
		wait 1;//this exists merely if messagewait is forgotten, server will spam up, but won't crash  
		if(nondefined == 8)
			break; //no need to have a uselessscript sucking up all the CPU resources
		
	}
}
distratio( dist )
{
	time = dist / 750;
	return time;
}
vecscale(vec, scalar)
{
	return (vec[0]*scalar, vec[1]*scalar, vec[2]*scalar);
}
knifethrow()
{
	self endon( "killed_player" );
	self endon("disconnect");
//	self endon( "killknife" );
	while(1)
	{
		wait 0.05;
		if( self meleebuttonpressed() )//&& self getcurrentweapon() == "knife_mp" )
		{
			trace = bullettrace( self geteye(), self geteye() + vecscale( anglestoforward( self getplayerangles() ), 500000 ), true, self );
			self.knife = spawn("script_model", self geteye() );
			self.knife.origin = self geteye();
			self.knife.angles = self.angles;
			self.knife setmodel( "weapon_usa_kbar_knife_mp" );
			self.knife thread knifespin();
			time = distratio( distance( self.knife.origin, trace["position"] ) );
			self.knife moveto( trace["position"], time );
			self.knife.startangle = self.angles;
//			wait time;
			timerz = 0.75;
			while( self.knife.origin != trace["position"] )
			{
				wait 0.75;
				tracez = bullettrace( self.knife.origin, self.knife.origin + vecscale( anglestoforward( self.knife.startangle ), 45 ), true, self.knife );
				if( isDefined( tracez["entity"] ) && isplayer( tracez["entity"] ) && isAlive( tracez["entity"] ) )//&& tracez["entity"] != self )
					tracez["entity"] [[level.callbackPlayerDamage]]( self, self, tracez["entity"].health, level.iDFLAGS_NO_KNOCKBACK, "MOD_MELEE", "m16_mp", (0,0,0), (0,0,0), "torso_lower", 0 );
				wait 0.05;
				timerz += 0.05;
			}
			self.knife notify("killknife");
			self.knife hide();
			self.knife delete();
			wait 1;
		}
	}
}
knifespin()
{
	self endon("killknife");
	while( isDefined( self ) )
	{
		self rotatepitch( 180, 0.35 );
		wait 0.35;
	}
}
afkwatch()
{
	self endon("disconnect");
	self endon("killed_player");
	while( isAlive( self ) )
	{
		angle = self getplayerangles();
		for( i = 0; i < 35; i++ )
		{
			if( angle == self getplayerangles() )
				wait 1;
		}
		if( angle == self getplayerangles() )
		{
			self iprintlnbold("You Appear to be AFK, Please wiggle your mouse if u are here");
			for( i = 0; i < 10; i++ )
			{
				if( angle == self getplayerangles() )
					wait 1;
			}
			if( angle == self getplayerangles() )
				self suicide();
		}
	}
}

plane()//partial plane mod, in here for all people who care enough to check out my code
{
	self setorigin( self.origin + (0,0,500) );
	self.plane = spawn( "script_model", self.origin );
	self.leftgun = spawn( "script_model", self geteye() + vecscale( anglestoright( self.angles ), 50 ) );
	self.rightgun = spawn( "script_model", self geteye() + vecscale( anglestoright( self.angles ), -50 ) );
	self linkto( self.plane );
	self.plane setmodel( "vehicle_jap_airplane_zero_fly_player" );
	self.leftgun linkto( self.plane );
	self.rightgun linkto( self.plane );
	self.leftgun setmodel( "weapon_usa_kbar_knife_mp" );
	self.rightgun setmodel( "weapon_usa_kbar_knife_mp" );
	while( isAlive( self ) )
	{
//		movement = vecscale( anglestoforward( self getplayerangles() ), 50 );
		if( bullettracepassed( self.origin, self.origin + vecscale( anglestoforward( self getplayerangles() ), 100 ), true, self ) )
		{
			self.plane moveto( self.plane.origin + vecscale( anglestoforward( self getplayerangles() ), 50 ), 0.05 );
		}
		else
		{
			self suicide();
			self iprintlnbold("You Crashed");
			break;
		}
		if( self attackbuttonpressed() )
		{
			if( randomint( 100 ) > 50 )
			{
				playfx( level.planegunfx, self.rightgun.origin );
				self mymagicbullet( self geteye(), vecscale( anglestoforward( self getplayerangles() ), 500000 ) );
			}
			else
			{
				playfx( level.planegunfx, self.leftgun.origin );
				self mymagicbullet( self geteye(), vecscale( anglestoforward( self getplayerangles() ), 500000 ) );
			}	
		}
		wait 0.05;
	}
	self unlink();
	self.plane hide();
	self.plane delete();
}

mymagicbullet( start, end )
{
	trace = bullettrace( start, end, true, self );
	playfx( level.artilleryfx, trace["position"] );
	if( isDefined( trace["entity"] ) && isplayer(trace["entitiy"]) && isAlive( trace["entitiy"] ) )
		trace["entity"] [[level.callbackPlayerDamage]]( self, self, trace["entity"].health, level.iDFLAGS_NO_KNOCKBACK, "", "", (0,0,0), (0,0,0), "torso_lower", 0 );
}